<?php

namespace BitGoblin\Goliath\Controllers;

use Psr\Http\Message\ResponseInterface as Response;
use Psr\Http\Message\ServerRequestInterface as Request;
use Slim\Routing\RouteContext;
use Slim\Views\Twig;
use BitGoblin\Goliath\Models\Queue;

class QueueController extends Controller {

  public function getView(Request $request, Response $response, array $args): Response {
    $queue = Queue::where('id', $args['queue_id'])->first();

    $view = Twig::fromRequest($request);
    return $view->render($response, 'queue/view.twig', [
      'queue' => $queue,
    ]);
  }

  public function getCreate(Request $request, Response $response): Response {
    $view = Twig::fromRequest($request);
    return $view->render($response, 'queue/create.twig');
  }

  public function postCreate(Request $request, Response $response): Response {
    $params = (array)$request->getParsedBody();

    $queue = new Queue;
    $queue->title = $params['queue_title'];
    $queue->description = $params['queue_description'];

    $queue->save();

    // redirect the user back to the home page
    $routeContext = RouteContext::fromRequest($request);
    $routeParser = $routeContext->getRouteParser();
    return $response
      ->withHeader('Location', $routeParser->urlFor('queue.view', ['queue_id' => $queue->id]))
      ->withStatus(302);
  }

}
